/* Utility functions, providing some kind of growable array
 * with the restriction that elements can only be added 
 * at the end of the list 
 */

#ifndef ArrayList_h_Included
#define ArrayList_h_Included

#include "jni.h"

typedef struct {
   void *elements;
   jint capacity;
   jint used;
} XrArrayList;

/* Initializes the list data strutures */
void initXRList(XrArrayList *list, jint capacity, size_t blkSize);

/* Returns a pointer to a blksize large memory area, 
   enlarging the underlaying array on demand */
void* getNewXR(XrArrayList *list, size_t blkSize);

/* Clears the list content */
void clearXRList(XrArrayList *list);

#endif /* ArrayList_h_Included */
